/*

ВНИМАНИЕ, ЭТО ПУБЛИЧНАЯ ВЕРСИЯ КОДА!
ОНА МОЖЕТ ОТЛИЧАТЬСЯ / ИМЕТЬ БОЛЕЕ СТАРЫЙ КОД, ЧЕМ ОСНОВНАЯ ВЕРСИЯ

*/

uint8_t S1 = A5;
uint8_t S2 = A4;
uint8_t S3 = A3;
uint8_t S4 = A2;
uint8_t S5 = A1;
uint8_t S6 = A0;

int sensorBarrier[6] = {800, 800, 800, 800, 800, 800};
int sensorWeights[6] = {-3, -2, -1, 1, 2, 3};
uint8_t sensorPins[6] = {A5, A4, A3, A2, A1, A0};
int sensorValues[6] = {0, 0, 0, 0, 0, 0};

double kP = ###;
double kI = ###;
double kD = ###;

double integral = 0;
double lastErr = 0;

uint8_t LS = 5;
uint8_t RS = 6;
uint8_t LD = 7;
uint8_t RD = 4;

int speedDef = 150;

void setup() {
  pinMode(S1, INPUT);
  pinMode(S2, INPUT);
  pinMode(S3, INPUT);
  pinMode(S4, INPUT);
  pinMode(S5, INPUT);
  pinMode(S6, INPUT);

  pinMode(LD, OUTPUT);
  pinMode(LS, OUTPUT);
  pinMode(RD, OUTPUT);
  pinMode(RS, OUTPUT);

  Serial.begin(9600);
}

void loop() {
  int position = 0; //degrees
  int activeSensors = 0; 
  double input = 0;
  /*Serial.print(dS1()); Serial.print(" | "); delay(10);
  Serial.print(dS2()); Serial.print(" | "); delay(10);
  Serial.print(dS3()); Serial.print(" | "); delay(10);
  Serial.print(dS4()); Serial.print(" | "); delay(10);
  Serial.print(dS5()); Serial.print(" | "); delay(10);
  Serial.print(dS6()); Serial.println(" | "); delay(10);*/

  for(int i = 0; i < 6; i++) 
  {
    sensorValues[i] = analogRead(sensorPins[i]);
    if (sensorValues[i] > sensorBarrier[i])
    {
      position += sensorWeights[i];
      activeSensors++;
    }
  }

  if (activeSensors > 0) {
    input = (double)position / activeSensors;
  } else { //потеря линии
    input = 0; 
  }

  double P = input;
  integral += input;
  double I = integral;
  double D = input - lastErr;

  lastErr = input;
  double totalErr = kP * P + kI * I + kD * D;

  lamotor(speedDef - totalErr); 
  ramotor(speedDef + totalErr);

  if (Serial.available()) {
    Serial.println(input);
  }
}

//custom

void lmotor(bool dir, int speed)
{
  analogWrite(LS, speed);
  if (dir) {
    digitalWrite(LD, HIGH);
  } else {
    digitalWrite(LD, LOW);
  }
}

void rmotor(bool dir, int speed)
{
  analogWrite(RS, speed);
  if (dir) {
    digitalWrite(RD, HIGH);
  } else {
    digitalWrite(RD, LOW);
  }
}

void lamotor(int speed)
{
  if (speed > 0) {
    digitalWrite(LD, HIGH);
    analogWrite(LS, abs( speed - (speed - 255) ));
  } else if (speed < 0) {
    digitalWrite(LD, LOW);
    analogWrite(LS, abs( speed - (speed - 255) ));
  } else {
    digitalWrite(LD, LOW);
    analogWrite(LS, 0);
  }
}

void ramotor(int speed)
{
  if (speed > 0) {
    digitalWrite(RD, HIGH);
    analogWrite(RS, abs( speed - (speed - 255) ));
  } else if (speed < 0) {
    digitalWrite(RD, LOW);
    analogWrite(RS, abs( speed - (speed - 255) ));
  } else {
    digitalWrite(RD, LOW);
    analogWrite(RS, 0);
  }
}
